Dia2Postgres - PHP module documentation



The PHP module is able to generate PHP4 classes that may be used to access the
base from a PHP4 script. The generated classes currently only work with table
that have an unique identifier.


I. PHP command line arguments

-p <phpout>
--php <phpout>
	Outputs PHP4 database access classes into <phpout>.


II. Using the generated classes

Your script needs to include the Dia2postgres-generated file first. Note that
the files in the distribution's php/ subdirectories must be somewhere in the
PHP include path for this to work.

	require_once ("outputscript.inc");

You will then have to connect to a PosgtreSQL database and attach the
connection resource to the manager :

	$pg = pg_connect(...);
	$d2pManager->setDatabaseConnection($pg);

You will then be able to :

	* Create new objects to be inserted into the base

		$obj = &$d2pManager->newObject("table_name");

	* Create objects from tables with an unique identifier :

		$obj = &$d2pManager->objectFromBase("table_name", "unique_id_value");

	* Create objects from tables with complex identifiers :

		$obj = &$d2pManager->objectFromBase("table_name", array(
			"fieldname"	=> "value",
			[...]
		));

	* Create objects lists from tables with a query :

		$olst = &$dm->listFromBase("table_name", "SQL query");

Each object may be read from via the getField method :

	echo $obj->getField("field_name");

...or modified via the setField method :

	$obj->setField("field_name", value);

Note : when a field is a foreign key, the value used for such a field
is an instance of the class that represents the destination table :

	$obj2 = &$obj->getField("foreign_key");
	$obj3 = &$dm->newObject("table_name");
	$obj3->setField("foreign_key", &$obj2);

You may use the instances to automatically output HTML forms that
reprents the data they contain :

	<FORM ACTION='action.php'><?=$obj3->getHTMLForm()?></FORM>

You may use two methods to get back form data :

 * If you are trying to create an object, you will have to create a new
object with the manager, then read form data through the object's
getFormInput() method :

	$obj = &$d2pManager->newObject($table);
	$obj->getFormInput();

 * If you are trying to modify an existing object, you need to call the
manager's objectFromForm() method, with the name of the table as its first
and unique parameter :

	$obj = &$d2pManager->objectFromForm($table);

If modifications are to be done into the database, the commit() method
of the manager's instance has to be called :

	$d2pManager->commit();

Please feel free to inspect the exemples for more details.
